<%--
/*  
 * Copyright (c) 2011 Ant Kutschera
 * 
 * This file is part of Ant Kutschera's blog, 
 * http://blog.maxant.co.uk
 * 
 * This is free software: you can redistribute
 * it and/or modify it under the terms of the
 * Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 * 
 * It is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the Lesser GNU General Public License for
 * more details. 
 * 
 * You should have received a copy of the
 * Lesser GNU General Public License along with this software.
 * If not, see http://www.gnu.org/licenses/.
 */
--%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>WebSockets Demo</title>

<script language="Javascript" type="text/javascript">

var data = {"container":
        	{"command": "", 
             "data": "", 
             "result": ""}
		   };

// the websockets instance
var ws;

//TODO use something like jQuery here!

function ws_connect(){
	document.getElementById("connect").disabled = "disabled";
	document.getElementById("buy").disabled = "disabled";
	document.getElementById("price").disabled = "disabled";
	document.getElementById("close").disabled = "disabled";

	var myDiv = document.getElementById("myDiv");
	myDiv.innerHTML = "connecting...";

	ws = new WebSocket("ws://localhost:8085/nio-websockets/TestServlet", "JSON");//?jsessionid=<%=session.getId()%>"); //, "TEXT");
	ws.onopen = function(evt) {
		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "open" + "<br>" + myDiv.innerHTML;

		document.getElementById("connect").disabled = "disabled";
		document.getElementById("buy").disabled = null;
		document.getElementById("price").disabled = null;
		document.getElementById("close").disabled = null;
	};
	
	ws.onmessage = function(evt) {
		data = JSON.parse(evt.data);

		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "received: " + data.container.result + "<br>" + myDiv.innerHTML;
	};
	
	ws.onclose = function(evt) {
		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "closed" + "<br>" + myDiv.innerHTML;

		ws = null;

		document.getElementById("connect").disabled = null;
		document.getElementById("buy").disabled = "disabled";
		document.getElementById("price").disabled = "disabled";
		document.getElementById("close").disabled = "disabled";
	};
	
	ws.onerror = function(evt) {
		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "error" + "<br>" + myDiv.innerHTML;
		
		ws = null;

		document.getElementById("connect").disabled = null;
		document.getElementById("buy").disabled = "disabled";
		document.getElementById("price").disabled = "disabled";
		document.getElementById("close").disabled = "disabled";
	};
}

function ws_buy(){
	if(ws && ws.readyState == WebSocket.prototype.OPEN){
		data.container.command = "BUY";
		data.container.data = "GOOG,100@200.25";

		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "buying: " + data.container.data + "..." + "<br>" + myDiv.innerHTML;

		ws.send(JSON.stringify(data));
	}
}

function ws_price(){
	if(ws && ws.readyState == WebSocket.prototype.OPEN){
		data.container.command = "PRICE";
		data.container.data = "GOOG";

		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "requesting price: " + data.container.data + "..." + "<br>" + myDiv.innerHTML;

		ws.send(JSON.stringify(data));
	}
}

function ws_close(){
	if(ws){
		var myDiv = document.getElementById("myDiv");
		myDiv.innerHTML = "closing..." + "<br>" + myDiv.innerHTML;

		data.container.command = "CLOSE";
		ws.send(JSON.stringify(data));

		document.getElementById("connect").disabled = ""; //because if we are already disconnected because of a timeout, and the browser hasnt realised yet, we dont want the user to have to wait until an onclose event arrives
		document.getElementById("buy").disabled = "disabled";
		document.getElementById("price").disabled = "disabled";
		document.getElementById("close").disabled = "disabled";
	}
}

</script>

</head>
<body>
<h2>Welcome to a WebSockets demo...</h2>
<br>
<button id="connect" onclick="return ws_connect();">Connect</button><br>
<button id="buy" onclick="return ws_buy();" disabled="disabled">Buy</button><br>
<button id="price" onclick="return ws_price();" disabled="disabled">Price</button><br>
<button id="close" onclick="return ws_close();" disabled="disabled">Close</button><br>

<%if(request.getUserPrincipal() == null || !request.isUserInRole("registered")){%>
	<a href='secure/index.jsp'>login...</a>
<%}else{%>
	you are logged in as <%=request.getUserPrincipal().getName() %>- this should work :-)
<%}%>
<hr>
<small>(newest logging data is shown at the top)</small><br>
<div id="myDiv"></div>

</body>
</html>