/*  
 * Copyright (c) 2011 Ant Kutschera
 * 
 * This file is part of Ant Kutschera's blog, 
 * http://blog.maxant.co.uk
 * 
 * This is free software: you can redistribute
 * it and/or modify it under the terms of the
 * Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 * 
 * It is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the Lesser GNU General Public License for
 * more details. 
 * 
 * You should have received a copy of the
 * Lesser GNU General Public License along with this software.
 * If not, see http://www.gnu.org/licenses/.
 */
package ch.maxant.blog.nio.webservices;

import java.math.BigDecimal;
import java.util.Random;

import javax.jws.WebMethod;
import javax.jws.WebService;

@WebService
public class PricingSystem {

	private Random random = new Random();
	
	/**
	 * returns the share price
	 * @param shareCode the share to lookup
	 * @return the price in bucks
	 */
	@WebMethod
	public BigDecimal getPrice(String shareCode){
		//zero to 100 bucks
		int cents = random.nextInt(10000);
		return new BigDecimal(cents).divide(new BigDecimal(100.0));
	}
}
